import "Turbine.UI";
import "Turbine.UI.Lotro";
import "KragenPlugs.Utils";
import "KragenPlugs.Utils.Extensions";
import "KragenPlugs.KragenSlots";

KSButton = class ( Turbine.UI.Window );

function KSButton:Constructor ( x, y )
	Turbine.UI.Window.Constructor( self );
	
	self.drag = false;
	self.moved = false;
	self.dragStartX = 0;
	self.dragStartY = 0;
	
	local displayWidth = Turbine.UI.Display:GetWidth();
	local displayHeight = Turbine.UI.Display:GetHeight();
	
	self:SetSize( 34, 35 );
	self:SetPosition(x, y);
	self:SetOpacity( .40 );
	self:SetVisible(true);
	self:SetMouseVisible(true);
	self:SetBackground( "KragenPlugs/KragenSlots/Resources/button.tga" );
	self:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
	
	
	self.MouseClick = function( sender, args )
		if (not self.moved) then
			if( args.Button == Turbine.UI.MouseButton.Left) then
				if(setup:IsVisible()) then
					setup:Close();
				else
					setup:SetVisible(true);
				end
			elseif( args.Button == Turbine.UI.MouseButton.Right and not setup:IsVisible() ) then
				local contextMenu = Turbine.UI.ContextMenu()
				local contextMenuItems = contextMenu:GetItems();
				
				local menuItem = Turbine.UI.MenuItem( "Lock All" );
				menuItem:SetChecked( setup.setupGeneral.buttonlock:GetText() ~= "Lock All" );
				menuItem.Click = function(sender, args)
					if (setup.setupGeneral.buttonlock:GetText() == "Lock All") then
						for k,v in pairs(slots) do
							v.settings.locked = true;
						end
						if (setup.setupSlots.slotlist:GetSelection() ~= 0 and setup.setupSlots.slotlist:GetSelection() ~= nil and setup.setupSlots.lockslot:IsChecked() ~= true) then
							setup.setupSlots.lockslot:SetChecked(true);
						end
						setup.setupGeneral.buttonlock:SetText("Unlock All");
					else
						for k,v in pairs(slots) do
							v.settings.locked = false;
						end
						if (setup.setupSlots.slotlist:GetSelection() ~= 0 and setup.setupSlots.slotlist:GetSelection() ~= nil and setup.setupSlots.lockslot:IsChecked() ~= false) then
							setup.setupSlots.lockslot:SetChecked(false);
						end
						setup.setupGeneral.buttonlock:SetText("Lock All");
					end
					menuItem:SetChecked( setup.setupGeneral.buttonlock:GetText() ~= "Lock All" );
				end
				contextMenuItems:Add( menuItem );
				
				local menuItem = Turbine.UI.MenuItem( "Windows Snap to Grid" );
				menuItem:SetChecked( settings.snaptogrid );
				menuItem.Click = function(sender, args)
					settings.snaptogrid = not settings.snaptogrid;
					setup.setupGeneral.snaptogrid:SetChecked(settings.snaptogrid);
					
				end
				contextMenuItems:Add( menuItem );
				
				local subMenu = Turbine.UI.MenuItem( "Slots" );
				local subMenuItems = subMenu:GetItems();
				for k, v in pairs(slots) do
					local slotMenu = Turbine.UI.MenuItem( v.name );
					local slotMenuItems = slotMenu:GetItems();
					
					local slotSubMenu = Turbine.UI.MenuItem( "Change On" );
					local slotSubMenuItems = slotSubMenu:GetItems();
					local menuItem = Turbine.UI.MenuItem( "Scroll" );
					menuItem:SetChecked( v.settings.changeon == 1 );
					menuItem.Click = function(sender, args)
						v:SetChangeOn(1);						
					end
					slotSubMenuItems:Insert( 1, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Click" );
					menuItem:SetChecked( v.settings.changeon == 2 );
					menuItem.Click = function(sender, args)
						v:SetChangeOn(2);
					end
					slotSubMenuItems:Insert( 2, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Both" );
					menuItem:SetChecked( v.settings.changeon == 3 );
					menuItem.Click = function(sender, args)
						v:SetChangeOn(3);
					end
					slotSubMenuItems:Insert( 3, menuItem );
					slotMenuItems:Add(slotSubMenu);
					
					local slotSubMenu = Turbine.UI.MenuItem( "Active" );
					local slotSubMenuItems = slotSubMenu:GetItems();
					local menuItem = Turbine.UI.MenuItem( "Always" );
					menuItem:SetChecked( v.settings.active == 1 );
					menuItem.Click = function(sender, args)
						v:SetActive(1);
					end
					slotSubMenuItems:Insert( 1, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Only In Combat" );
					menuItem:SetChecked( v.settings.active == 2 );
					menuItem.Click = function(sender, args)
						v:SetActive(2);
					end
					slotSubMenuItems:Insert( 2, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Only Out of Combat" );
					menuItem:SetChecked( v.settings.active == 3 );
					menuItem.Click = function(sender, args)
						v:SetActive(3);
					end
					slotSubMenuItems:Insert( 3, menuItem );
					slotMenuItems:Add(slotSubMenu);
					
					local slotSubMenu = Turbine.UI.MenuItem( "Preview" );
					local slotSubMenuItems = slotSubMenu:GetItems();
					local menuItem = Turbine.UI.MenuItem( "None" );
					menuItem:SetChecked( v.settings.preview == 1 );
					menuItem.Click = function(sender, args)
						v:SetPreview(1);
					end
					slotSubMenuItems:Insert( 1, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Horizontal" );
					menuItem:SetChecked( v.settings.preview == 2 );
					menuItem.Click = function(sender, args)
						v:SetPreview(2);
					end
					slotSubMenuItems:Insert( 2, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Vertical" );
					menuItem:SetChecked( v.settings.preview == 3 );
					menuItem.Click = function(sender, args)
						v:SetPreview(3);
					end
					slotSubMenuItems:Insert( 3, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Horizontal: Always Show" );
					menuItem:SetChecked( v.settings.preview == 4 );
					menuItem.Click = function(sender, args)
						v:SetPreview(4);
					end
					slotSubMenuItems:Insert( 4, menuItem );
					local menuItem = Turbine.UI.MenuItem( "Vertical: Always Show" );
					menuItem:SetChecked( v.settings.preview == 5 );
					menuItem.Click = function(sender, args)
						v:SetPreview(5);
					end
					slotSubMenuItems:Insert( 5, menuItem );
					slotMenuItems:Add(slotSubMenu);
					
					subMenuItems:Add(slotMenu);
				end
				contextMenuItems:Add(subMenu);
				
				contextMenu:ShowMenu();
			end
		end
	end
	
	self.MouseDown = function( sender, args)
		self.drag = true;
		self.moved = false;
		self.dragStartX = args.X;
		self.dragStartY = args.Y;
	end
	
	self.MouseMove = function( sender, args)
		if (self.drag) then
			local left, top = self:GetPosition();
			self:SetPosition( math.min( math.max( left + ( args.X - self.dragStartX ), 0 ), Turbine.UI.Display:GetWidth() - self:GetWidth() )
							, math.min( math.max( top + ( args.Y - self.dragStartY ), 0 ), Turbine.UI.Display:GetHeight() - self:GetHeight()) );
			
			local newx, newy = self:GetPosition();
			if (self.dragStartX ~= newx or self.dragStartY ~= newy) then
				self.moved = true;
			end
		end
	end
	
	self.MouseUp = function( sender, args )
		self.drag = false;
		settings.KSButton.x, settings.KSButton.y = self:GetPosition();
	end
	
	self.MouseEnter = function(sender, args)
		self:SetOpacity(.85);
	end
	
	self.MouseLeave = function(sender, args)
		self:SetOpacity(.4);
	end
	

end

