import "Turbine.UI";

SetupGeneral = class(Turbine.UI.ListBox);

-- helper functions
local tt = function(width, height, control, text)
    local tooltip = KragenPlugs.UI.Tooltip();
    tooltip:SetText(text);
    tooltip:SetControl(control);
    tooltip:SetSize(width, height);
end

local holder = function(parent, height)
    local container = Turbine.UI.Control();
    container:SetSize(400, height);
    parent:AddItem(container);
    return container;
end


function SetupGeneral:Constructor()
    Turbine.UI.ListBox.Constructor(self);
	
    self:SetOrientation(Turbine.UI.Orientation.Horizontal);
    self:SetMaxItemsPerLine(1);

	local line = holder(self, 60);
    local title = KragenPlugs.UI.PanelDivider();
    title:SetPosition(0,0);
    title:SetParent(line);
    title:SetText("General");
    title:SetSize(400, 30);
	
	line = holder(self,50);
	self.ksbutton = KragenPlugs.UI.CheckBox();
	self.ksbutton:SetParent(line);
	self.ksbutton:SetSize(180, 20);
	self.ksbutton:SetPosition(0,0);
	self.ksbutton:SetText("Show KS Icon");
	self.ksbutton:SetVisible(true);
	
	self.buttonlock = Turbine.UI.Lotro.Button();
    self.buttonlock:SetParent(line);
	self.buttonlock:SetPosition(250, 0);
    self.buttonlock:SetSize(100, 22);
    self.buttonlock:SetText("Lock All");
	self.buttonlock:SetVisible(true);
	
	line = holder(self, 30);
	self.snaptogrid = KragenPlugs.UI.CheckBox();
	self.snaptogrid:SetParent(line);
	self.snaptogrid:SetSize(180, 20);
	self.snaptogrid:SetPosition(0,0);
	self.snaptogrid:SetText("Snap Slots to Grid");
	self.snaptogrid:SetVisible(true);
	
	local line = holder(self, 50);
    self.gridsize = KragenPlugs.UI.Slider();
    self.gridsize:SetParent(line);
    self.gridsize:SetText("Grid Size (pixels)");
    self.gridsize:SetPosition(49, 0);
    self.gridsize:SetSize(350, 40);
    self.gridsize:SetStep(9);
    self.gridsize:SetMin(9);
    self.gridsize:SetMax(36);
	self.gridsize:SetVisible(true);
	
end