import "Turbine.UI";

SetupSlots = class(Turbine.UI.ListBox);

-- helper functions
local tt = function(width, height, control, text)
    local tooltip = KragenPlugs.UI.Tooltip();
    tooltip:SetText(text);
    tooltip:SetControl(control);
    tooltip:SetSize(width, height);
end

local holder = function(parent, height)
    local container = Turbine.UI.Control();
    container:SetSize(400, height);
    parent:AddItem(container);
    return container;
end


function SetupSlots:Constructor()
    Turbine.UI.ListBox.Constructor(self);

    self:SetOrientation(Turbine.UI.Orientation.Horizontal);
    self:SetMaxItemsPerLine(1);

	local line = holder(self, 35);
    local title = KragenPlugs.UI.PanelDivider();
    title:SetPosition(0,0);
    title:SetParent(line);
    title:SetText("Slots");
    title:SetSize(400, 30);

    line = holder(self, 30);
    self.slotlist = KragenPlugs.UI.ComboBox();
    self.slotlist:SetParent(line);
    self.slotlist:SetSize(190, 20);
    self.slotlist:SetPosition(0, 0);
    self.slotlist:SetVisible(false);
	self.slotlist:SetVisible(true);
	
	self.slotnamebox = Turbine.UI.Lotro.TextBox();
    self.slotnamebox:SetParent(line);
    self.slotnamebox:SetSize(180, 20);
    self.slotnamebox:SetPosition(210, 0);
    self.slotnamebox:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    self.slotnamebox:SetMultiline(false);
	self.slotnamebox:SetVisible(false);
	self.slotnamebox:SetWantsUpdates(true);
	self.slotnamebox.Update = function(sender,args)
		if (self.slotlist:GetSelection() ~= 0 and slots[self.slotlist:GetSelection()] ~= nil) then
			self.slotlist:UpdateSelectionText(self.slotnamebox:GetText());
			slots[self.slotlist:GetSelection()].name = self.slotnamebox:GetText();
			slots[self.slotlist:GetSelection()].dragBar.sName = self.slotnamebox:GetText();
			slots[self.slotlist:GetSelection()].dragBar.Label:SetText(self.slotnamebox:GetText());
		end
	end
	
	line = holder(self,30);
	self.slotbuttonnew = Turbine.UI.Lotro.Button();
    self.slotbuttonnew:SetParent(line);
	self.slotbuttonnew:SetPosition(60, 0);
    self.slotbuttonnew:SetSize(100, 22);
    self.slotbuttonnew:SetText("New");
	self.slotbuttonnew:SetVisible(true);

    self.slotbuttonremove = Turbine.UI.Lotro.Button();
    self.slotbuttonremove:SetParent(line);
    self.slotbuttonremove:SetPosition(240, 0);
    self.slotbuttonremove:SetSize(100, 22);
    self.slotbuttonremove:SetText("Remove");
	self.slotbuttonremove:SetVisible(false);
	
	line = holder(self, 35);
    title = KragenPlugs.UI.PanelDivider();
    title:SetPosition(0,0);
    title:SetParent(line);
    title:SetText("Edit Slot");
    title:SetSize(400, 30);
	
	line = holder(self, 60);
	self.lockslot = KragenPlugs.UI.CheckBox();
	self.lockslot:SetParent(line);
	self.lockslot:SetSize(180, 20);
	self.lockslot:SetPosition(0,0);
	self.lockslot:SetText("Lock Slot");
	self.lockslot:SetVisible(false);
	
	line = holder(self, 30);
	self.changeon = { };
	self.changeon.label = KragenPlugs.UI.Label();
    self.changeon.label:SetParent(line);
    self.changeon.label:SetSize(190, 20);
    self.changeon.label:SetPosition(20, 0);
    self.changeon.label:SetText("Change On");
    self.changeon.label:SetVisible(false);
    
    self.changeon.combobox = KragenPlugs.UI.ComboBox();
    self.changeon.combobox:SetParent(line);
    self.changeon.combobox:SetSize(190, 20);
    self.changeon.combobox:SetVisible(false);
    self.changeon.combobox:SetPosition(210, 0);
	local combolist = {"Scroll", "Click", "Both"};
	for k,v in pairs(combolist) do
		self.changeon.combobox:AddItem(v, k);
	end
	
	line = holder(self, 30);
	self.active = { };
	self.active.label = KragenPlugs.UI.Label();
    self.active.label:SetParent(line);
    self.active.label:SetSize(190, 20);
    self.active.label:SetPosition(20, 0);
    self.active.label:SetText("Active");
    self.active.label:SetVisible(false);
    
    self.active.combobox = KragenPlugs.UI.ComboBox();
    self.active.combobox:SetParent(line);
    self.active.combobox:SetSize(190, 20);
    self.active.combobox:SetVisible(false);
    self.active.combobox:SetPosition(210, 0);
	local combolist = {"Always", "Only In Combat", "Only Out of Combat"};
	for k,v in pairs(combolist) do
		self.active.combobox:AddItem(v, k);
	end
	
	line = holder(self, 60);
	self.preview = { };
	self.preview.label = KragenPlugs.UI.Label();
    self.preview.label:SetParent(line);
    self.preview.label:SetSize(190, 20);
    self.preview.label:SetPosition(20, 0);
    self.preview.label:SetText("Preview");
    self.preview.label:SetVisible(false);
    
    self.preview.combobox = KragenPlugs.UI.ComboBox();
    self.preview.combobox:SetParent(line);
    self.preview.combobox:SetSize(190, 20);
    self.preview.combobox:SetVisible(false);
    self.preview.combobox:SetPosition(210, 0);
	local combolist = {"None", "Horizontal", "Vertical", "Horizontal: Always Show", "Vertical: Always Show"};
	for k,v in pairs(combolist) do
		self.preview.combobox:AddItem(v, k);
	end
	
	line = holder(self, 30);
	self.hover = KragenPlugs.UI.CheckBox();
	self.hover:SetParent(line);
	self.hover:SetSize(180, 20);
	self.hover:SetPosition(0,0);
	self.hover:SetText("Hover Effect");
	self.hover:SetVisible(false);
	
	local line = holder(self, 50);
    self.minopacity = KragenPlugs.UI.Slider();
    self.minopacity:SetParent(line);
    self.minopacity:SetText("Minimum Opacity");
    self.minopacity:SetPosition(49, 0);
    self.minopacity:SetSize(350, 40);
    self.minopacity:SetStep(1);
    self.minopacity:SetMin(0);
    self.minopacity:SetMax(100);
	self.minopacity:SetVisible(false);
	
	local line = holder(self, 50);
    self.maxopacity = KragenPlugs.UI.Slider();
    self.maxopacity:SetParent(line);
    self.maxopacity:SetText("Maximum Opacity");
    self.maxopacity:SetPosition(49, 0);
    self.maxopacity:SetSize(350, 40);
    self.maxopacity:SetStep(1);
    self.maxopacity:SetMin(0);
    self.maxopacity:SetMax(100);
	self.maxopacity:SetVisible(false);
	
end